;---------- My Routines ------------;    
dispAnsNL:
    call    dispAns
    bcall(_newline)
    ret

dispAns:
    ld      a,15
    bcall(_formreal)
    ld      hl,op3
    bcall(_puts)
    ret

dispSquaredAns:
    ld      a,$10
    bcall(_putc)
    call    dispAnsNL
    bcall(_sqroot)
    jp      dispAns

dispSquaredAnsWK:
    call    dispSquaredAns
    jp      waitkey

putsWaitKey:
    bcall(_puts)
    jp      waitkey

getNumberNL:
    call    getNumber
    bcall(_newline)
    ret

getXpromptY:
    call    getNumberNL
    ld      hl,strYequ
    call    putsNewLine
    ret

pNLpromptX:
    call    putsNewLine
    ld      hl,strXequ
    call    putsNewLine
    ret

ckOP2Pos:
    bcall(_op2toop1)
ckOP1Pos:                           ;Check if OP1 is greater than zero
    bcall(_ckop1pos)                ; If not, displays "Only positive numbers!"
    jr      nz,co1p1                ; and returns to Maths Pack.
    bcall(_ckop1fp0)
    ret     nz
co1p1:
    pop     hl
    ld      hl,strNoNeg
    bcall(_puts)
    jp      waitkey

heroSolve:
    ld      hl,side1
    call    putsNewLine
    ld      b,2
heroBrah:                               ;Finds area of cyclic quad. or triangle given sides
    push    bc
    ld      de,float1
    call    getNumberNL
    call    f1toop2
    call    ckOP2Pos
    ld      hl,side2
    call    putsNewLine
    ld      de,float2
    call    getNumberNL
    call    f2toop2
    call    ckOP2Pos
    ld      hl,side3
    call    putsNewLine
    ld      de,float3
    call    getNumberNL
    call    f3toop2
    call    ckOP2Pos
    pop     bc
    djnz    heroCont
    push    bc
    ld      hl,side4
    call    putsNewLine
    ld      de,float4
    call    getNumberNL
    call    f2toop2
    call    ckOP2Pos
    jr      brahCont

heroCont:
    push    bc
    bcall(_op1set0)
    ld      hl,op1
    ld      de,float4
    call    pushOp
brahCont:
    call    f1toop2
    bcall(_op2toop1)
    call    f2toop2
    bcall(_fpadd)
    call    f3toop2
    bcall(_fpadd)
    call    f4toop2
    bcall(_fpadd)
    bcall(_timespt5)                    ; s found!
    call    pushOp1
    call    f1toop2
    bcall(_fpsub)
    bcall(_op1toop2)
    call    pushOp2
    call    f2toop2
    call    popOp1
    bcall(_fpsub)
    bcall(_op1toop3)
    call    pushOp3
    call    f3toop2
    call    popOp1
    bcall(_fpsub)
    bcall(_op1toop4)
    call    pushOp4
    call    f4toop2
    call    popOp1
    bcall(_fpsub)
    call    popOp2
    bcall(_fpmult)
    call    popOp3
    bcall(_op3toop2)
    bcall(_fpmult)
    call    popOp4
    bcall(_op4toop2)
    bcall(_fpmult)
    pop     bc
    bcall(_ckop1pos)
    jr      nz,heroBrahError
    bcall(_ckop1fp0)
    jr      nz,heroBrahAns
heroBrahError:
    ld      hl,strBrah
    djnz    heroBrahErrorShow
    ld      hl,strHero
heroBrahErrorShow:
    jp      putsWaitKey

heroBrahAns:
    call    cls
    ld      hl,area
    call    putsNewLine
    jp      dispSquaredAnsWK

choice:
    set     textInverse,(iy+textflags)
    bcall(_homeup)
    ld      hl,strMPChoose
    call    putsNewLine
    res     textInverse,(iy+textflags)
    ret

op1set180:
    bcall(_op1set3)
    bcall(_op2set60)
    bcall(_fpmult)
    ret

op2set180:
    call    op1set180
    bcall(_op1toop2)
    ret

f1toop2:
    ld      hl,op2
    ld      de,float1
    jp      popOp
f2toop2:
    ld      hl,op2
    ld      de,float2
    jp      popOp
f3toop2:
    ld      hl,op2
    ld      de,float3
    jp      popOp
f4toop2:
    ld      hl,op2
    ld      de,float4
    jp      popOp

saveop1f9:
    ld      hl,op1
    ld      de,float9
    jp      pushOp

loadop2f9:
    ld      hl,op2
    ld      de,float9
    jp      popOp

strYequ:
    .db     "Y=",0

strNoNeg:
    .db     "Only positive   "
    .db     "numbers!",0

strMPChoose:
    .db     "  Enter Choice  ",0
;----------------------------------;

;slope.asm strings      - DONE
;pgonarea.asm strings   - DONE
;polygon.asm strings - DONE
;tangent.asm strings - DONE

strXequ:
    .db     "X=",0

distAndRadii:
    .db     "Enter distance  "
    .db     "and two radii.  "
distance:
    .db     "Distance:",0

numSides:
    .db     "Number of Sides:",0

numSidesInvalid:
    .db     "The number of   "
    .db     "sides is an     "
    .db     "an integer and  "
    .db     "at least 3.",0
    
sideLengthPos:
    .db     "The length of a "
    .db     "side must be    "
    .db     "positive.",0

area:
    .db     "Area:",0

brahma:
    .db     "Enter 4 sides   "
    .db     "of a cyclic     "
    .db     "quadrilateral.  "
side1:
    .db     "Side 1:",0

side2:
    .db     "Side 2:",0

side3:
    .db     "Side 3:",0

side4:
    .db     "Side 4:",0

strBrah:
    .db     "Not a cyclic    "
    .db     "quadrilateral.",0

strHero:
    .db     "Not a triangle.",0

.end
    

