;-----------------------------------------------------------;
;                                                           ;
; Maths Pack by James Vernon                                ;
;                                                           ;
; Calculate the area of a regular polygon given             ;
;  number of sides and length of a side OR                  ;
;  area of a cyclic quadrilateral given four                ;
;  sides using Brahmagupta's formula.                       ;
;                                                           ;
; By Andrey Gorlin <ag_silver_83p@ameritech.net>            ;
;                                                           ;
;-----------------------------------------------------------;

pgonAreaName:
    .db     "Polygon Area Finder",0

pgonArea:
    call    choice
    ld      hl,strPgonAreaChoose
    bcall(_puts)
pgonAreaWait:
    call    waitkey
    cp      GK_MODE
    jp      z,waitkey
    cp      GK_GRAPH
    jp      z,pgonAreaCh2
    cp      GK_Y
    jr      nz,pgonAreaWait
pgonAreaCh1:
    call    cls
    set     trigdeg,(iy+trigflags)
    ld      hl,strPgonArea              ; Display:
pgonAreaAns:
    bcall(_puts)                        ;"Enter Number of..."
    ld      de,paNS
    call    getNumberNL                 ;Get number of sides.
    call    paLoadNS                    ;Do various checks on vaNS.
    bcall(_op2toop1)
    bcall(_op2set3)                     ;Is it at least 3?
    bcall(_fpsub)
    bcall(_ckposint)
    jr      z,pgonAreaCont              ;If 3 or greater and integer, continue.
    ld      hl,strPgonAreaInv
pgonAreaError:
    jp      putsWaitKey                 ; Display error message and return to Maths Pack.

pgonAreaCont:
    ld      hl,strPgonAreaLength        ; Display:
    call    putsNewLine                 ;"Length of Side:"
    ld      de,paLS
    call    getNumberNL                 ;Get length.
    call    paLoadLS
    call    ckOP2Pos                    ;Check if positive.
    call    cls
    ld      hl,strPgonAreaAns           ; Display:
    call    putsNewLine                 ;"Area:"
    call    op1set180                   ;Formula used to find area:
    call    paLoadNS                    ; a = NS, b = LS
    bcall(_fpdiv)                       ; b^2*a/(4tan(180/a))
    bcall(_tan)
    bcall(_times2)
    bcall(_times2)
    call    paLoadNS
    bcall(_op1exop2)
    bcall(_fpdiv)
    call    saveop1f9
    call    paLoadLS
    bcall(_op2toop1)
    bcall(_fpsquare)
    call    loadop2f9
    bcall(_fpmult)                      ; Area Found!
    bcall(_fpsquare)
    jp      dispSquaredAnsWK

pgonAreaCh2:
    call    cls                         ;Brahmagupta's formula:
    ld      hl,strPgonAreaBr            ; a=s1, b=s2, c=s3, d=s4
    call    putsNewLine                 ; s=(a+b+c+d)/2
    ld      b,1
    jp      heroBrah                    ;Function will finish there.

paNS    =   float1
paLS    =   float2

paLoadNS =  f1toop2
paLoadLS =  f2toop2

strPgonAreaChoose:
    .db     "F1: Reg. Polygon"
    .db     "F5: Brahmagupta",0

strPgonArea     =   numSides
;   .db     "Number of Sides:",0

strPgonAreaInv  =   numSidesInvalid
;   .db     "The number of   "
;   .db     "sides must be an"
;   .db     "integer and at  "
;   .db     "least 3.",0

strPgonAreaLength:
    .db     "Length of Side:",0

strPgonAreaAns  =   area
;   .db     "Area:",0

strPgonAreaBr   =   brahma
;   .db     "Enter 4 sides   "
;   .db     "of a cyclic     "
;   .db     "quadrilateral.  "
;   .db     "Side 1:",0

.end
