;-----------------------------------------------------------:
;                                                           ;
; Maths Pack by James Vernon                                ;
; Calculate number of sides, diagonals, and sum of angles   ;
;  given one of the three.                                  ;
; By Andrey Gorlin <ag_silver_83p@ameritech.net>            ;
;                                                           ;
;-----------------------------------------------------------;

poSides =   1
poDiag  =   2
poAngle =   3

polygonName:
    .db     "Polygon Helper",0

polygon:
    call    choice
    ld      hl,strPolygonChoose
    bcall(_puts)

polygonMenu:
    call    waitkey
    cp      GK_Y
    jr      z,polygonSides              ;Input Sides
    cp      GK_ZOOM
    jr      z,polygonDiag               ;Input Diagonals
    cp      GK_GRAPH
    jp      z,polygonAS                 ;Input Sum of Angles
    cp      GK_MODE
    jr      nz,polygonMenu
    ret                                 ;Return to Maths Pack.

polygonSides:
    ld      b,poSides
    push    bc
    call    cls
    ld      hl,strPolygonSides          ; Display:
    bcall(_puts)                        ;"Number of Sides:"
    ld      de,op1
    call    getNumberNL
    jp      polygonCheckNum

polygonDiag:
    ld      b,poDiag
    push    bc
    call    cls
    ld      hl,strPolygonDiag           ; Display:
    call    putsNewLine                 ;"Number of Diagonals:"
    ld      de,op1
    call    getNumberNL
    bcall(_ckop1pos)                    ;check if positive
    jr      nz,polygonError             ;error label
    bcall(_times2)
    bcall(_op1toop2)                    ;Diagonals --> Sides
    call    pushOp2                     ; a=diagonals
    bcall(_op1set3)                     ;1.5+sqrt(2a+2.25)
    bcall(_timespt5)
    call    pushOp1
    bcall(_fpsquare)
    call    popOp2
    bcall(_fpadd)
    bcall(_sqroot)
    bcall(_op1toop2)
    call    popOp1
    bcall(_fpadd)
    jr      polygonCheckNum

polygonAS:
    ld      b,poAngle
    push    bc
    call    cls
    ld      hl,strPolygonAS             ; Display:
    call    putsNewLine                 ;"Sum of Angles:"
    ld      de,op1
    call    getNumberNL                 ;Sum of Angles --> Sides
    call    pushOp1                     ; a=sum of angles
    call    op2set180                   ;  A
    call    popOp1                      ; --- + 2
    bcall(_fpdiv)                       ; 180
    bcall(_op2set2)
    bcall(_fpadd)

polygonCheckNum:
    call    pushOp1
    bcall(_op2set3)
    bcall(_fpsub)
    bcall(_ckposint)
    jr      z,polygonCont
polygonError:
    pop     bc
    ld      hl,strPolygonSidesError
    djnz    polygonE2
polygonE1:
    jp      putsWaitKey

polygonE2:
    ld      hl,strPolygonDiagError
    bcall(_puts)
    djnz    polygonE3
    jr      polygonE1

polygonE3:
    ld      hl,strPolygonASError
    jr      polygonE1

polygonCont:
    pop     bc
    call    cls
    ld      hl,strPolygonSides          ; Display:
    bcall(_puts)                        ;"Number of Sides:"
    call    popOp1
    call    dispAnsNL                   ; Display sides.
    ld      hl,strPolygonDiag           ; Display:
    call    putsNewLine                 ;"Number of Diagonals:"
    bcall(_op2set3)
    bcall(_fpsub)                       ; sides --> diagonals
    bcall(_timespt5)                    ; a=sides
    bcall(_op1toop2)                    ; a(a-3)
    call    popOp1                      ; ------
    bcall(_fpmult)                      ;   2
    call    dispAnsNL                   ; Display diagonals.
    ld      hl,strPolygonAS             ; Display:
    call    putsNewLine                 ;"Sum of Angles:"
    call    popOp1
    bcall(_op2set2)                     ; sides --> sum of angles
    bcall(_fpsub)                       ; a=sides
    call    pushOp1
    call    op2set180                   ; 180(a-2)
    call    popOp1
    bcall(_fpmult)
    call    dispAns                     ;Sum of Angles found!
    jp      waitkey                     ;Return to Maths Pack.

strPolygonChoose:
    .db     "F1: Sides       "
    .db     "F3: Diagonals   "
    .db     "F5: Angle Sum",0

strPolygonSides     =       numSides
;   .db     "Number of Sides:",0

strPolygonDiag:
    .db     "Number of       "
    .db     "Diagonals:",0

strPolygonAS:
    .db     "Sum of Angles:",0

strPolygonSidesError    =   numSidesInvalid
;   .db     "The number of   "
;   .db     "sides is an     "
;   .db     "an integer and  "
;   .db     "at least 3.",0
    
strPolygonDiagError:
    .db     "No polygon has  "
    .db     "this ",0
    .db          "amount of  "
    .db     "diagonals.",0

strPolygonASError:
    .db          "sum of     "
    .db     "angles.",0

.end
