;-----------------------------------------------------------;
;                                                           ;
;Maths Pack by James Vernon                                 ;
;Calculate the distance between a point and a line given    ;
; the location of the point and the equation of the line.   ;
;By: Andrey Gorlin <ag_silver_83p@ameritech.net>            ;
;                                                           ;
;-----------------------------------------------------------;

ptLineName:
    .db     "Point to Line Distance",0

ptLine:
    ld      hl,strPtLinePrompt          ;Ask for line:
    call    putsNewLine
    ld      de,plA                      ;Input A
    call    getNumberNL
    ld      hl,strPtLineB
    call    putsNewLine
    ld      de,plB                      ;Input B
    call    getNumberNL
    call    plLoadA                     ;If both are zero, then error.
    bcall(_op2toop1)
    bcall(_ckop1fp0)
    jr      nz,ptLineFine
    call    plLoadB
    bcall(_op2toop1)
    bcall(_ckop1fp0)
    jr      nz,ptLineFine
ptLineError:
    ld      hl,strPtLine2zeros          ;Load error message
    jp      putsWaitKey                 ;Return to Maths Pack.

ptLineFine:
    ld      hl,strPtLineC
    call    putsNewLine
    ld      de,plC                      ;Input C
    call    getNumberNL
    ld      hl,strPtLinePt              ;Ask for point (r,s).
    call    putsNewLine
    ld      de,op1                      ;Input r
    call    getNumberNL
    ld      hl,strPtLineS
    call    putsNewLine
    ld      de,op2                      ;Input s
    call    getNumber
ptLineDispAns:
    call    cls
    ld      hl,strPtLineAns
    call    putsNewLine
    call    pushOp2                     ; |Ar + Bs + C|
    call    plLoadA                     ; -------------
    bcall(_fpmult)                      ; sqrt(A^2+B^2)
    call    pushOp1
    call    popOp2
    bcall(_op2toop1)
    call    plLoadB
    bcall(_fpmult)
    bcall(_op1toop2)
    call    popOp1
    bcall(_fpadd)
    call    plLoadC
    bcall(_fpadd)
    call    pushOp1
    call    plLoadA
    bcall(_op2toop1)
    call    plLoadB
    bcall(_cabs)                        ;takes sqr(op1^2+op2^2) :)
    bcall(_op1toop2)
    call    popOp1
    bcall(_fpdiv)                       ;Distance found!
    bcall(_fpsquare)
    jp      dispSquaredAnsWK


plA     =   float1
plB     =   float2
plC     =   float3

plLoadA =   f1toop2
plLoadB =   f2toop2
plLoadC =   f3toop2

strPtLinePrompt:
    .db     "Enter Equation: "
    .db     "Ax + By + C = 0 "
    .db     "A=",0

strPtLineB:
    .db     "B=",0

strPtLineC:
    .db     "C=",0

strPtLinePt:
    .db     "Point (r,s):    "
    .db     "r=",0

strPtLineS:
    .db     "s=",0

strPtLineAns = distance
;   .db     "Distance:",0

strPtLine2zeros:
    .db     "Both A and B    "
    .db     "cannot be zero!",0
