;-----------------------------------------------------------;
;                                                           ;
;Maths Pack by James Vernon                                 ;
;Calculate distance, midpoint, slope, and the intercepts    ;
;   given two points.                                       ;
;By: Andrey Gorlin <ag_silver_83p@ameritech.net>            ;
;                                                           ;
;-----------------------------------------------------------;

slopeName:
    .db     "Coordinate Master",0

slope:
    ld      hl,strSlope
    call    pNLpromptX
    ld      de,slX1                 ;Ask for x1 (x,y).
    call    getXpromptY
    ld      de,slY1                 ;Ask for y1.
    call    getNumberNL
    ld      hl,strSlope2
    call    pNLpromptX
    ld      de,slX2                 ;Ask for x2.
    call    getXpromptY
    ld      de,slY2                 ;Ask for y2.
    call    getNumberNL             ;Check if same point:
    call    slopeYdiff              ;Check y values
    jr      nz,slopeResume
    call    slopeXdiff              ;Check x values
    jr      nz,slopeResume
slopeSamePt:                        ;If both were equal
    ld      hl,strSlopeSamePt       ; Display:
    jp      putsWaitKey             ;"Same Point!" and return

slopeResume:
    call    cls
    ld      hl,strSlopeDist         ; Display:
    call    putsNewLine             ;"Distance:"
    call    slopeYdiff              ;Formula for distance:
    bcall(_fpsquare)                ;sqr((x1-x2)^2+(y1+y2)^2)
    call    saveop1f9
    call    slopeXdiff
    bcall(_fpsquare)
    call    loadop2f9
    bcall(_fpadd)
    call    dispSquaredAns
    bcall(_newline)
    bcall(_newline)

    ld      hl,strSlopeMidpt        ; Display:
    call    putsNewLine             ;"Midpoint:"
    bcall(_puts)                    ;"("
    call    slLoadX1                ;Formula for midpt:
    bcall(_op2toop1)
    call    slLoadX2                ; x1+x2 y1+y2
    bcall(_fpadd)                   ;(-----,-----)
    bcall(_timespt5)                ;   2     2
    call    dispAns
    ld      a,','
    bcall(_putc)                    ; Display:
    call    slLoadY1                ;"(" x-midpt "," y-midpt ")"
    bcall(_op2toop1)
    call    slLoadY2
    bcall(_fpadd)
    bcall(_timespt5)
    call    dispAns
    ld      a,')'
    bcall(_putc)
    call    waitkey                 ;Pause here.

    call    cls
    ld      hl,strSlopeAns          ; Display:
    call    putsNewLine             ;"Slope:"
    call    slopeXdiff              ;Load diff. into op1 and check if 0.
    jr      z,slopeNone             ; If so, there is no slope.
    bcall(_op1toop2)                ;Formula for the slope:
    call    pushOp2                 ; y1-y2
    call    slopeYdiff              ; -----
    call    popOp2                  ; x1-x2
    bcall(_fpdiv)
    call    pushOp1                 ;store slope for later use.
    call    dispAnsNL               ; Display:
    bcall(_newline)                 ;slope

    ld      hl,strSlopeYAns         ; Display:
    call    putsNewLine             ;"Y-Intercept:"
    call    slLoadX1                ;Formula for y-int:
    call    popOp1                  ;y-(slope*x)
    bcall(_fpmult)
    call    slLoadY1
    bcall(_op1exop2)
    bcall(_fpsub)
    call    dispAnsNL
    call    slopeYdiff              ;If y-values are equal, then no x-int.
    jp      z,waitkey               ;So, then you would quit.
                                    
    call    slopeXAns               ; Display:
    call    popOp1                  ;"X-Intercept:"
    call    slLoadY1
    bcall(_op1exop2)                ;Formula for x-int:
    bcall(_fpdiv)                   ;     y
    call    slLoadX1                ;x-(-----)
    bcall(_op1exop2)                ;   slope
    bcall(_fpsub)
    call    dispAns
    jp      waitkey                 ;return to Maths Pack

slopeNone:
    ld      hl,strSlopeNo           ; Display:
    call    putsNewLine             ;"No Slope."
    bcall(_newline)
    call    slopeXAns               ; Display:
    call    slLoadX1                 ;"X-Intercept:"
    bcall(_op2toop1)                ;x1 value (matches x-int)
    call    dispAns
    jp      waitkey                 ;return to Maths Pack

slopeXAns:
    ld      hl,strSlopeXAns         ; Display:
    jp      putsNewLine             ;"X-Intercept:"

slopeYdiff:
    call    slLoadY1
    bcall(_op2toop1)
    call    slLoadY2
    bcall(_fpsub)
    bcall(_ckop1fp0)                ;check if y1-y2=0
    ret

slopeXdiff:
    call    slLoadX1
    bcall(_op2toop1)
    call    slLoadX2
    bcall(_fpsub)
    bcall(_ckop1fp0)                ;check if x1-x2=0
    ret


slX1    =   float1
slX2    =   float3
slY1    =   float2
slY2    =   float4

slLoadX1 =   f1toop2
slLoadY1 =   f2toop2
slLoadX2 =   f3toop2
slLoadY2 =   f4toop2

strSlope:
    .db     "Enter two points"
    .db     "in (x,y) format."
    .db     "Point 1:",0
strSlopeX   = strXequ
;   .db     "X=",0

strSlope2:
    .db     "Point 2:",0

strSlopeDist    =   distance
;   .db     "Distance:",0

strSlopeMidpt:
    .db     "Midpoint:",0
    .db     "(",0

strSlopeAns:
    .db     "Slope:",0

strSlopeYAns:
    .db     "Y-Intercept:",0

strSlopeXAns:
    .db     "X-Intercept:",0

strSlopeNo:
    .db     "No Slope",0

strSlopeSamePt:
    .db     "Same Point!",0


.end

