;-----------------------------------------------------------:
;                                                           ;
; Maths Pack by James Vernon                                ;
; Calculate common internal and external tangents of        ;
;  2 circles given their radii and distance b/w them.       ;
; By Andrey Gorlin <ag_silver_83p@ameritech.net>            ;
;                                                           ;
;-----------------------------------------------------------;

tangentName:
    .db     "Common Tangent Solver",0

tangent:
    ld      hl,strTangentAskNum         ;prompt string
    call    putsNewLine
    ld      de,op1
    call    getNumberNL                 ;Input Distance
    call    pushOp1
    call    ckOP1Pos
    ld      hl,strTangentR1             ; Display:
    call    putsNewLine                 ;"Radius 1:"
    ld      de,op2
    call    getNumberNL                 ;Input Radius 1
    call    pushOp2
    call    ckOP2Pos
    ld      hl,strTangentR2             ; Display:
    call    putsNewLine                 ;"Radius 2:"
    ld      de,op3
    call    getNumberNL                 ;Input Radius 2
    call    pushOp3
    bcall(_op3toop1)
    call    ckOP1Pos
tangentCont:
    call    cls                         ;Formulas:
    call    popOp1                      ;a=distance
    bcall(_fpsquare)                    ;b=r1, c=r2
    call    pushOp1
    ld      hl,strTangentInternal       ; Display:
    call    putsNewLine                 ;"Internal:"
    ld      b,1
    push    bc
tangentSolver:                          ;solver loops twice
    call    popOp2                      ;internal:
    call    popOp3                      ;sqrt(a^2-(b+c)^2)
    bcall(_op3toop1)
    bcall(_fpadd)                       ;external:
    bcall(_fpsquare)                    ;sqrt(a^2-(b-c)^2)
    bcall(_op1toop2)
    call    popOp1
    bcall(_fpsub)
    bcall(_ckop1pos)                    ;check if positive.
    jr      nz,tangentNone              ;if not, display "None."
    call    dispSquaredAns
tangentFinish:
    pop     bc
    djnz    tangentQuit
    push    bc
    bcall(_newline)
    bcall(_newline)
    ld      hl,strTangentExternal       ; Display:
    call    putsNewLine                 ;"External:"
    call    popOp2
    bcall(_invop2s)                     ;Inverts one radius to subtract
    call    pushOp2                     ; instead of adding.
    jr      tangentSolver

tangentNone:
    ld      hl,strTangentNone           ; Display:
    bcall(_puts)                        ;"None."
    jr      tangentFinish

tangentQuit:
    jp      waitkey                     ;Return to Maths Pack.


strTangentAskNum    =   distAndRadii
;   .db     "Enter distance  "
;   .db     "and two radii.  "
;   .db     "Distance:",0

strTangentR1:
    .db     "Radius 1:",0

strTangentR2:
    .db     "Radius 2:",0

strTangentInternal:
    .db     "Internal:",0

strTangentExternal:
    .db     "External:",0

strTangentNone:
    .db     "None.",0
